﻿using DataGridExample.CustomRenderer;
using DataGridExample.ViewModels;
using Syncfusion.SfDataGrid.XForms;
using System.Diagnostics;
using Xamarin.Forms;

namespace DataGridExample.Views
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            BindingContext = new MainPageViewModel();
                
            //var template = MyDataGrid.CellRenderers["Template"];
            //MyDataGrid.CellRenderers.Remove("Template");
            //MyDataGrid.CellRenderers.Add("Template", new CustomGridCellTemplateRenderer());
        }
        protected override void OnParentSet()
        {
            base.OnParentSet();
            Debug.WriteLine($"OnParentSet HasContext={BindingContext != null}");
            if (BindingContext is MainPageViewModel)
            {
                AddDynamicRows(new MainPageViewModel());
            }
        }

        private void AddDynamicRows(MainPageViewModel context)
        {
            //var dtSpecial = this.Resources["special"] as DataTemplate;
            //var dtNormal = this.Resources["normal"] as DataTemplate;
            var dtOther = this.Resources["boundtemplate"] as DataTemplate;

            for (int i = 0; i < context.CodesCollection.Count; i++)
            {
                //var templateSelector = new JobCodeTemplateSelector(i)
                //{
                //    Special = dtSpecial,
                //    Normal = dtNormal,
                //};

                var code = context.CodesCollection[i];

                var valueBinding = new Binding()
                {
                    Path = $"JobCodeCollection[{i}]"
                };

                var mappingName = $"JobCodeCollection[{i}]";

                var col = new GridTemplateColumn();
                col.HeaderText = code;
                col.MappingName = mappingName;
                col.Width = 100;

                var cellTemplate = new DataTemplate(() =>
                {
                    var label = new Label();
                    label.HorizontalOptions = LayoutOptions.Center;
                    label.VerticalOptions = LayoutOptions.Center;
                    label.SetBinding(Label.TextProperty, new Binding(mappingName, converter: new ValueConverter(),converterParameter: null));
                    return label;
                });
                col.CellTemplate = cellTemplate;
               
                MyDataGrid.Columns.Add(col);
            }
        }

        //public DataTemplate CreateDataTemplate(int index)
        //{
        //    var markup = @"
        //    <DataTemplate>
        //        < Grid >
        //             < Grid.ColumnDefinitions >
        //                 < ColumnDefinition Width = ""Auto"" />
        //                  < ColumnDefinition Width = ""*"" />
        //               </ Grid.ColumnDefinitions >
        //               < Image
        //                            Grid.Column = ""0""
        //                            Aspect = ""AspectFit""
        //                            WidthRequest = ""10""
        //                            Source = ""{Binding JobCodeCollection[{i}], Converter ={ StaticResource imageConverter}}"" />
        //            <Label
        //                            x:Name=""changeValue"" 
        //                            Grid.Column=""1""
        //                            Text=""{Binding JobCodeCollection[{i}], Converter={StaticResource valueConverter}}"" 
        //                            TextColor=""Black""
        //                            XAlign=""Center"" 
        //                            YAlign=""Center"">
        //            </Label>
        //        </Grid>
        //    </DataTemplate>"; 
            
        //    var template = (DataTemplate)XamlReader.Load(markup);
            
        //    return template;
        //}
    }

}
